<template>
  <div>
    <a-input-group compact>
      <a-input
        disabled
        style="width: calc(100% - 32px)"
        v-model:value="value"
        :placeholder="placeholder"
      />
      <a-button @click="openEdit">
        <template #icon><BulbOutlined class="ele-text-warning" /></template>
      </a-button>
    </a-input-group>
    <!-- 选择弹窗 -->
    <SelectData
      v-model:visible="showEdit"
      :data="current"
      :title="placeholder"
      :customer-type="customerType"
      @done="onChange"
    />
  </div>
</template>

<script lang="ts" setup>
  import { BulbOutlined } from '@ant-design/icons-vue';
  import { ref } from 'vue';
  import SelectData from './components/select-data.vue';
  import { Project } from '@/api/tower/project/model';

  const props = withDefaults(
    defineProps<{
      value?: any;
      customerType?: string;
      placeholder?: string;
      index?: number;
    }>(),
    {
      placeholder: '请选择数据'
    }
  );

  const emit = defineEmits<{
    (e: 'done', TowerModel): void;
    (e: 'clear'): void;
    (e: 'multiple', any): void;
  }>();

  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 当前编辑数据
  const current = ref<Project | null>(null);

  /* 打开编辑弹窗 */
  const openEdit = (row?: Project) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  const onChange = (row) => {
    // 第几行
    row.index = Number(props.index);
    emit('done', row);
  };
</script>
